package
{
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	
	import frocessing.display.F5MovieClip2DBmp;

	/**
	 * FrocessingPart
	 * @author yasu
	 * 
	 * @see FrocessingSample by nutsu http://wonderfl.net/c/kvXp
	 */
	public class FrocessingPart extends F5MovieClip2DBmp
	{

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function FrocessingPart():void
		{
			visible = false;
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		private var cnt:int = 0;
		private var stageH:Number;
		private var stageW:Number;
		private var t:Number = 0;

		private var vertexArr:Array;

		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------

		public function setup():void
		{
			stage.addEventListener(Event.RESIZE, resize);
			resize(null);
			visible = true;

			vertexArr = [[], [], []];
			var i:int;
			for (i = 0; i <= 5; i++)
				vertexArr[0][i] = 0;
			for (i = 0; i <= 4; i++)
				vertexArr[1][i] = 0;
			for (i = 0; i <= 3; i++)
				vertexArr[2][i] = 0;
		}

		public function draw():void
		{
			// pre effect
			if (cnt++ % 5 == 0)
			{
				bitmapData.applyFilter(bitmapData, bitmapData.rect, new Point(), new BlurFilter(2, 2, 1));
				bitmapData.colorTransform(bitmapData.rect, new ColorTransform(1, 1, 1, 0.99));

			}

			// draw
			translate(0, 200);

			var i:int;
			t += 0.013;

			// draw #1
			stroke(255, 0.04);
			beginShape();
			curveVertex(-100, 0);
			for (i = 0; i <= 5; i++)
			{
				vertexArr[0][i] += ((noise(i * 0.25, t) * 400 - 200) - vertexArr[0][i]) * 0.1;
				curveVertex(i * stageW / 5, vertexArr[0][i]);
			}
			curveVertex(stageW + 100, 0);
			endShape();

			// draw #2
			stroke(255, 0.06);
			beginShape();
			curveVertex(-100, 0);
			for (i = 0; i <= 4; i++)
			{
				vertexArr[1][i] += ((noise(i * 0.25, t) * 400 - 200) - vertexArr[1][i]) * 0.1;
				curveVertex(i * stageW / 4, vertexArr[1][i]);
			}
			curveVertex(stageW + 100, 0);
			endShape();

			// draw #3
			stroke(255, 0.08);
			beginShape();
			curveVertex(-100, 0);
			for (i = 0; i <= 3; i++)
			{
				vertexArr[2][i] += ((noise(i * 0.25, t) * 400 - 200) - vertexArr[2][i]) * 0.1;
				curveVertex(i * stageW / 3, vertexArr[2][i]);
			}
			curveVertex(stageW + 100, 0);
			endShape();
		}

		private function resize(event:Event):void
		{
			stageW = stage.stageWidth;
			stageH = stage.stageHeight;
			size(stageW, 400);

			y = stageH - 400;

			background(0, 0);
			noFill();
		}
	}
}
